/*****************************

	i.ching
	
	Based on PatternOracle
	pattern processing engine
	
	version 0.5.0
	
	s y n c h r o n i z m
	synchronizm@mac.com
	
	(c) 2005
	All Rights Reserved.
	
	-------------------
	trigram.js
	
	-------------------
	
******************************/

function Trigram(bottomYao, middleYao, topYao) {
	
	// functions
	this.computeState = computeTrigramState;
	this.initializeTrigramMap = initializeTrigramMap;
	this.updateState = updateState;
	this.setState = trace; // overwritten
	
	this.state = new Object();
	this.state_array = new Array();

	// initialize
	this.initializeTrigramMap();	
	
	// create yao
	this.top_yao = new Yao(topYao, this);
	this.middle_yao = new Yao(middleYao, this);
	this.bottom_yao = new Yao(bottomYao, this);
	
	// link yao
	this.top_yao.setState = this.updateState;
	this.middle_yao.setState = this.updateState;
	this.bottom_yao.setState = this.updateState;

}

// set state
function updateState(state) {
	
	// Update the trigram
	stable_kua.lower_trigram.computeState();
	stable_kua.upper_trigram.computeState();
	
}

// compute state
function computeTrigramState() {
	
	var state_obj = new Object();
	var state_array = this.state_array;
	var bottom_yao = this.bottom_yao;
	var middle_yao = this.middle_yao;
	var top_yao = this.top_yao;

	this.initializeTrigramMap();
	
	// search
	for(var i=0; i<state_array.length; i++) {
		
		// look for matches
		if((state_array[i].yao[0] == bottom_yao.state.flow) && (state_array[i].yao[1] == middle_yao.state.flow) && (state_array[i].yao[2] == top_yao.state.flow)) {
			
			state_obj = state_array[i];
			
		}
	}
	
	// send state
	this.state = state_obj;
	
	// report
	trace("[Trigram] Trigram is " + this.state.name);
	
	// update and notify
	this.setState(state_obj);
	
}

// load state
function initializeTrigramMap() {
	
	// load states
	this.state_array[0] = new Object();
	this.state_array[0].yao = new Array();
	this.state_array[0].name = "Heaven";
	this.state_array[0].number = 1;
	this.state_array[0].flow = true;
	this.state_array[0].balance = false;
	this.state_array[0].yao[0] = true;
	this.state_array[0].yao[1] = true;
	this.state_array[0].yao[2] = true;
	
	this.state_array[1] = new Object();
	this.state_array[1].yao = new Array();
	this.state_array[1].name = "Lake";
	this.state_array[1].number = 2;
	this.state_array[1].flow = true;
	this.state_array[1].balance = false;
	this.state_array[1].yao[0] = true;
	this.state_array[1].yao[1] = true;
	this.state_array[1].yao[2] = false;
	
	this.state_array[2] = new Object();
	this.state_array[2].yao = new Array();
	this.state_array[2].name = "Fire";
	this.state_array[2].number = 3;
	this.state_array[2].flow = false;
	this.state_array[2].balance = true;
	this.state_array[2].yao[0] = true;
	this.state_array[2].yao[1] = false;
	this.state_array[2].yao[2] = true;
	
	this.state_array[3] = new Object();
	this.state_array[3].yao = new Array();
	this.state_array[3].name = "Thunder";
	this.state_array[3].number = 4;
	this.state_array[3].flow = false;
	this.state_array[3].balance = true;
	this.state_array[3].yao[0] = true;
	this.state_array[3].yao[1] = false;
	this.state_array[3].yao[2] = false;
	
	this.state_array[4] = new Object();
	this.state_array[4].yao = new Array();
	this.state_array[4].name = "Wind";
	this.state_array[4].number = 5;
	this.state_array[4].flow = true;
	this.state_array[4].balance = true;
	this.state_array[4].yao[0] = false;
	this.state_array[4].yao[1] = true;
	this.state_array[4].yao[2] = true;
	
	this.state_array[5] = new Object();
	this.state_array[5].yao = new Array();
	this.state_array[5].name = "Water";
	this.state_array[5].number = 6;
	this.state_array[5].flow = true;
	this.state_array[5].balance = true;
	this.state_array[5].yao[0] = false;
	this.state_array[5].yao[1] = true;
	this.state_array[5].yao[2] = false;
	
	this.state_array[6] = new Object();
	this.state_array[6].yao = new Array();
	this.state_array[6].name = "Mountain";
	this.state_array[6].number = 7;
	this.state_array[6].flow = false;
	this.state_array[6].balance = false;
	this.state_array[6].yao[0] = false;
	this.state_array[6].yao[1] = false;
	this.state_array[6].yao[2] = true;
	
	this.state_array[7] = new Object();
	this.state_array[7].yao = new Array();
	this.state_array[7].name = "Earth";
	this.state_array[7].number = 8;
	this.state_array[7].flow = false;
	this.state_array[7].balance = false;
	this.state_array[7].yao[0] = false;
	this.state_array[7].yao[1] = false;
	this.state_array[7].yao[2] = false;
	
}



